#include <iostream>

using namespace std;

class Fahrzeug {
   protected:
    string marke;
    string kennzeichen;
    int ps;
    int baujahr;

   public:
    // Standardkonstruktor
    Fahrzeug() {}

    // Konstruktor mit Elementinitialisierungsliste
    Fahrzeug(string mr, string kenn, int ps, int bj): 
        marke(mr), kennzeichen(kenn), ps(ps), baujahr(bj) {} 

    void datenausgeben() {
        cout << "Marke: " << marke;
        cout << "Kennzeichen: " << kennzeichen << endl;
        cout << "Anzahl PS: " << ps << endl;
        cout << "Baujahr: " << baujahr << endl;
    }
};

class PKW : public Fahrzeug {
   private:
    float maxGeschwindigkeit;

   public:
    PKW() {}

    PKW(string m, string kenn, int ps, int bj, float max): 
        Fahrzeug(m, kenn, ps, bj), maxGeschwindigkeit(max) {} 

    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Geschwindigkeit: " << maxGeschwindigkeit << endl;
    }
};

class LKW : public Fahrzeug {
   private:
    float maxLadung;
    int anzahlRaeder;

   public:
    LKW() {}

    LKW(string m, string kenn, int ps, int bj, float max, int anz): 
        Fahrzeug(m, kenn, ps, bj), maxLadung(max), anzahlRaeder(anz) {}

    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Ladung: " << maxLadung << endl;
        cout << "Anzal Raeder: " << anzahlRaeder << endl;
    }
};

int main() {
    Fahrzeug f1("Audi", "AO RT 333", 110, 2010);
    Fahrzeug f2("BMW", "C PP 33", 150, 2009);
    f1.datenausgeben();
    f2.datenausgeben();
    PKW p1("Opel", "KA WA 11", 78, 2004, 150);
    LKW l1("Mercedes", "WA SS 44", 99, 2007, 5.4, 8);
    p1.datenausgeben();
    l1.datenausgeben();

    return 0;
};
