#include <iostream>

using namespace std;

class Fahrzeug {
   protected:
    string marke;
    string kennzeichen;
    int ps;
    int baujahr;

   public:
    // Standardkonstruktor
    Fahrzeug() {}

    // Konstruktor mit Elementinitialisierungsliste
    Fahrzeug(string mr, string kenn, int ps, int bj): marke(mr), kennzeichen(kenn), ps(ps), baujahr(bj) {}

    void datenausgeben() {
        cout << "Marke: " << marke;
        cout << "Kennzeichen: " << kennzeichen << endl;
        cout << "Anzahl PS: " << ps << endl;
        cout << "Baujahr: " << baujahr << endl;
    }

    void setMarke(string mar) { marke = mar; }
    void setKennzeichen (string kenn) { kennzeichen = kenn; }
    void setPS (int p) { ps = p; }
    void setBaujahr (int bj) { baujahr = bj; }
};

class PKW : public Fahrzeug {
   private:
    float maxGeschwindigkeit;

   public:
    PKW() {}
    PKW(string m, string kenn, int ps, int bj, float max): Fahrzeug(m, kenn, ps, bj), maxGeschwindigkeit(max) {}
    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Geschwindigkeit: " << maxGeschwindigkeit << endl;
    }
    void setMaxGeschwindigkeit(float max) { maxGeschwindigkeit = max; }
};

class LKW : public Fahrzeug {
   private:
    float maxLadung;
    int anzahlRaeder;

   public:
    LKW() {}
    LKW(string m, string kenn, int ps, int bj, float max, int anz): Fahrzeug(m, kenn, ps, bj), maxLadung(max), anzahlRaeder(anz) {}

    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Ladung: " << maxLadung << endl;
        cout << "Anzal Raeder: " << anzahlRaeder << endl;
    }

    void setMaxLadung(float max) { maxLadung = max; }
    void setAnzahlRaeder(int anz) { anzahlRaeder = anz; }
};

int main() {
    PKW pkw;
    PKW *p1;

    p1 = &pkw;

    p1->setMarke("Opel");
    p1->setKennzeichen("KA WA 11");
    p1->setBaujahr(2004);
    p1->setPS(78);
    p1->setMaxGeschwindigkeit(200);

    LKW lkw;
    LKW *l1;
    l1 = &lkw;

    l1->setMarke("Mercedes");
    l1->setKennzeichen("WA SS 44");
    l1->setPS(99);
    l1->setBaujahr(2007);
    l1->setMaxLadung(5.4);
    l1->setAnzahlRaeder(8);

    p1->datenausgeben();
    l1->datenausgeben();

    return 0;
};
