#include <iostream>

using namespace std;

class Fahrzeug {
   protected:
    string marke;
    string kennzeichen;
    int ps;
    int baujahr;

   public:
    // Standardkonstruktor
    Fahrzeug() {}

    // Konstruktor mit Elementinitialisierungsliste
    Fahrzeug(string mr, string kenn, int ps, int bj): marke(mr), kennzeichen(kenn), ps(ps), baujahr(bj) {}

    void datenausgeben() {
        cout << "Marke: " << marke;
        cout << "Kennzeichen: " << kennzeichen << endl;
        cout << "Anzahl PS: " << ps << endl;
        cout << "Baujahr: " << baujahr << endl;
    }

    void init (string m, string kenn, int p, int bj) {
        marke = m;
        kennzeichen = kenn;
        ps = p;
        baujahr = bj;
    }
};

class PKW : public Fahrzeug {
   private:
    float maxGeschwindigkeit;

   public:
    PKW() {}
    PKW(string m, string kenn, int ps, int bj, float max): Fahrzeug(m, kenn, ps, bj), maxGeschwindigkeit(max) {}
    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Geschwindigkeit: " << maxGeschwindigkeit << endl;
    }

    void init (string m, string kenn, int p, int bj, float max) {
        Fahrzeug::init(m, kenn, p, bj);
        maxGeschwindigkeit = max;
    }
};

class LKW : public Fahrzeug {
   private:
    float maxLadung;
    int anzahlRaeder;

   public:
    LKW() {}
    LKW(string m, string kenn, int ps, int bj, float max, int anz): Fahrzeug(m, kenn, ps, bj), maxLadung(max), anzahlRaeder(anz) {}

    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Ladung: " << maxLadung << endl;
        cout << "Anzal Raeder: " << anzahlRaeder << endl;
    }

    void init (string m, string kenn, int p, int bj, float max, int anz) {
        Fahrzeug::init(m, kenn, p, bj);
        maxLadung = max;
        anzahlRaeder = anz;
    }
};

int main() {
    PKW pkw;
    PKW *p1;
    p1 = &pkw;

    LKW lkw;
    LKW *l1;
    l1 = &lkw;

    p1->init("Opel", "KA WA 11", 78, 2004, 150);
    l1->init("Mercedes", "WA SS 44", 99, 2007, 5.4, 8);

    p1->datenausgeben();
    l1->datenausgeben();

    return 0;
};
