#include <iostream>

using namespace std;

class Fahrzeug {
   protected:
	string marke;
	string kennzeichen;
	int ps;
	int baujahr;

   public:
    // Standardkonstruktor
    Fahrzeug() {}

    // Konstruktor mit Elementinitialisierungsliste
    Fahrzeug(string mr, string kenn, int ps, int bj): marke(mr), kennzeichen(kenn), ps(ps), baujahr(bj) {}

    void datenausgeben() {
		cout << "Marke: " << marke << endl;
		cout << "Kennzeichen: " << kennzeichen << endl;
		cout << "Anzahl PS: " << ps << endl;
		cout << "Baujahr: " << baujahr << endl;
    }
};

class PKW : public Fahrzeug {
   private:
    float maxGeschwindigkeit;

   public:
    // default constructor
    PKW() {}
    // Konstruktor mit Elementinitialisierungsliste
    PKW(string m, string kenn, int ps, int bj, float max): Fahrzeug(m, kenn, ps, bj), maxGeschwindigkeit(max) {}

    void datenausgeben() {
        Fahrzeug::datenausgeben();
        cout << "Maximale Geschwindigkeit: " << maxGeschwindigkeit << endl;
    }

    // Statische Methode, kann auch ohne Instanz aufgerufen werden
    static PKW* init(PKW *p) {
		string marke, kennzeichen;
		int ps, baujahr;
		float geschwindigket; 
		cout << "Marke: ";
		cin >> marke;
		cout << "Kennzeichen: ";
		cin >> kennzeichen;
		cout << "Anzahl PS: ";
		cin >> ps;
		cout << "Baujahr: "; 
		cin >> baujahr;
		cout << "Gewchwindigkeit: ";
        cin >> geschwindigket;
        p = new PKW(marke, kennzeichen, ps, baujahr, geschwindigket);
        return p;
    }
};

class LKW : public Fahrzeug {
   private:
	float maxLadung;
	int anzahlRaeder;

   public:
    // Standardkonstruktor
    LKW() {}
    // Konstruktor mit Elementinitialisierungsliste
	LKW(string m, string kenn, int ps, int bj, float max, int anz): Fahrzeug(m, kenn, ps, bj), maxLadung(max), anzahlRaeder(anz) {}
	
	void datenausgeben() {
		Fahrzeug::datenausgeben();
		cout << "Maximale Ladung: " << maxLadung << endl;
		cout << "Anzal Raeder: " << anzahlRaeder << endl;
    }

    static LKW* init(LKW *l) {
		string marke, kennzeichen;
		int ps, baujahr, anzahlRaeder;
		float maxLadung; 
		cout << "Marke: " << endl;
		cin >> marke;
		cout << "Kennzeichen: " << endl;
		cin >> kennzeichen;
		cout << "Anzahl PS: " << endl;
		cin >> ps;
		cout << "Baujahr: " << endl; 
		cin >> baujahr;
		cout << "Maximale Ladung: " << endl;
		cin >> maxLadung;
		cout << "Anzahl Raeder: " << endl;
		cin >> anzahlRaeder;
        l = new LKW(marke, kennzeichen, ps, baujahr, maxLadung, anzahlRaeder);
        return l;
    }
};

int main() {
	PKW *p[3];
	LKW *l[3];

	cout << endl << ".................... PKW erfassen .........................." << endl;
	for (int i = 0; i < 3; i++) { 
		cout << "PKW " << i+1 << ": " << endl << endl;
		//init Methode ist eine statische Methode, diese kann ohne Instanz aufgerufen werden
		//übergabe ist Zeiger auf das i-te Element --> call by referenz
        p[i] = PKW::init(p[i]);
	} 

	cout << endl << ".................... LKW erfassen .........................." << endl;
	for (int k = 0; k < 3; k++) {
		cout << "LKW " << k+1 << ": " << endl << endl;
		//init Methode ist eine statische Methode, diese kann ohne Instanz aufgerufen werden
		//übergabe ist Zeiger auf das i-te Element --> call by referenz
		l[k] = LKW::init(l[k]); 
	}

	cout << endl << "................. PKW ausgeben .................." << endl;
	for (int j = 0; j < 3; j++) {
		cout << "PKW " << j+1 << ": " << endl;
		p[j]->datenausgeben(); 
	}

	cout << endl << "................. LKW ausgeben .................." << endl;
	for (int j = 0; j < 3; j++) {
		cout << "LKW " << j+1 << ": " << endl;
		l[j]->datenausgeben(); 
	}

    return 0;
};
