#include <stdlib.h>
#include <ctime>
#include <iostream>

using namespace std;

class Kreatur {
   protected:
    int leben, schaden;

   public:
    Kreatur(){};
	Kreatur(int l) : leben(l) {	};  // Konstruktor mit Elementinitialisierung
    void setLeben(int);             // Leben von Kreatur setzen 
    int getLeben();                 // Leben von Kreatur zurückgeben
    void setSchaden(int);           // Schaden von Kreatur setzen 
    int getSchaden();               // Schaden von Kreatur zurückgeben
	void attacke(Kreatur*); 
};

void Kreatur::setLeben(int healthPoints) { this->leben = leben; }

int Kreatur::getLeben() { return leben; }

void Kreatur::setSchaden(int damschadenage) { this->schaden = schaden; }

int Kreatur::getSchaden() { return schaden; }

void Kreatur::attacke(Kreatur *k) { k->leben = k->leben - this->getSchaden(); }

class Spieler : public Kreatur {
   private:
    bool lebenstrank;

   public:
    Spieler() : Kreatur(100), lebenstrank(true){};  // Konstruktor mit Elementinitialisierung. Spieler hat am Anfang 100 Lebenspunkte und einen Lebenstrank
    void setLebenstrank();                          // Lebenstrank wird eingesetzt
    bool getLebenstrank();                          // True = Lebenstrank kann eingesetzt werden | False = Lebenstrank kann nicht eingesetzt werden
};

void Spieler::setLebenstrank() {
    this->lebenstrank = false;                          // Spieler hat keinen lebenstrank mehr
    srand(time(NULL));                                  // Zufallszahl initialisieren
    int randomLeben = rand() % (30 - 20) + 20;          // Zufallszahl zwischen 20 und 30
    this->leben+=randomLeben;                           // Leben vom Spieler erhöht sich
    cout << randomLeben << " Lebenpunkte erhalten!" << endl;
}

bool Spieler::getLebenstrank() { return lebenstrank; }

int main() {
	int besiegte_kreaturen = 0;
	int auswahl;
	int randomLeben;
	int randomSchaden;
    Kreatur *monster = new Kreatur();
    Spieler *spieler = new Spieler();
    do {
        system("cls");  //Löscht den Bildschirm für Windows-Systeme. Für Unix verwenden Sie system("clear"); - Sie können es auch weglassen
		cout << "Lebenspunkte: " << spieler->getLeben() << endl << endl;
		cout << "--AUSWAHL--" << endl;
		cout << "[1] Kaempfen" << endl;
		cout << "[2] Lebenstrank trinken" << endl;
		cout << "[3] Fliehen" << endl;
		cout << "Auswahl: ";
		cin >> auswahl;

        switch (auswahl) {
            case 1: {
                system("cls");
                monster = new Kreatur(); // Neue Kreatur taucht auf
                srand(time(NULL));              // Zufallsgenerator initialisieren 
                randomLeben = rand() % (50-30) + 30; // Zufallszahl zwischen 50 und 30
                monster->setLeben(randomLeben); // Leben wird gesetzt
                do {
                    cout << "Der Spieler hat " << spieler->getLeben() << " Lebenspunkte." << endl; // Ausgabe Lebenspunkte Spieler
                    cout << "Das Monster hat " << monster->getLeben() << " Lebenspunkte." << endl << endl; // Ausgabe Lebenspunkte Monster

                    randomSchaden = rand() % (20 - 10) + 10; // Zufallszahl zwischen 20 und 10
                    spieler->setSchaden(randomSchaden);  // Schadenspunkte für Spieler werden gesetzt  					
                    randomSchaden = rand() % (20 - 10) + 10; // Zufallszahl zwischen 20 und 10
                    monster->setSchaden(randomSchaden);  // Schadenspunkte für Monster werden gesetzt  	
                    
                    spieler->attacke(monster); // Spieler greift Monster an
                    cout << "Spieler hat " << spieler->getSchaden() << " Schaden zugefuegt." << endl; // Ausgabe des Schadens vom Spieler
                    
                    if (monster->getLeben() <= 0) // Sollte das Monster weniger als 1 Lebenspunkt haben, stirbt es
                    {
                        cout << "Monster ist gestorben!" << endl;
                        besiegte_kreaturen++;
                        if (besiegte_kreaturen == 3)  // Falls der Spieler 3 Kreaturen besiegt hat, dann hat er gewonnen
                        {
                            cout << endl << "Gewonnen! Sie haben den Schatz erreicht!" << endl;
                            if(spieler->getLebenstrank()) // Falls Lebenstrank noch vorhanden ist, kommt eine weitere Meldung
                                cout << " ...und das ohne einen Lebenstrank einzusetzen! Sie sind ein wahrer Held!" << endl;
                            cout << "Anzahl besiegter Kreaturen: " << besiegte_kreaturen << endl;
                            auswahl = 3;
                        }
                        break;
                    } else
                        monster->attacke(spieler); // Sollte das Monster noch Leben, dann greift es an

                    cout << "Monster hat " << monster->getSchaden() << " Schaden zugefuegt." << endl << endl; // Ausgabe des Schadens vom Monster

                    if(spieler->getLeben() <= 0) // Sollte der Spieler weniger als 1 Lebenspunkt haben, stirbt er
                    {
                        cout << "Leider gestorben!" << endl;
                        cout << "Anzahl besiegter Kreaturen: " << besiegte_kreaturen << endl;
                        auswahl = 3;
                        return 0;
                    }

                } while (true);
                cin.ignore();
                cin.get();
                break;
            }
            case 2: {
                system("cls");
                if(spieler->getLebenstrank())
                    spieler->setLebenstrank();
                else
                    cout << "Kein Lebenstrank vorhanden." << endl;
                cin.ignore();
                cin.get();
                break;
            }
            case 3: {
                cout << endl << "Sie sind geflohen!" << endl;
                cout << "Anzahl besiegter Kreaturen: " << besiegte_kreaturen << endl;
                cin.ignore();
                cin.get();
                break;
            }
            default: {
                cout << endl << "Falsche Auswahl!" << endl;
                cin.ignore();
                cin.get();
                break;
            }
        }
    } while (auswahl != 3);

    delete monster;
    delete spieler;

    return 0;
}
