#include <stdlib.h>
#include <iostream>

using namespace std;

class Fahrzeug {
   protected:
    int Anzahl;

   public:
    Fahrzeug(){};                         // Default constructor
    Fahrzeug(int numb) : Anzahl(numb){};  // Constructor with member initializer list
    int getAnzahl() const { return Anzahl; }
};

class Auto : public Fahrzeug {
    // friend Declaration
    friend class Autoliste;
    // Attribute
   private:
    int AutoNr;
    float Gewicht;
    Auto *Nachfolger;  //  Verkettungszeiger zum Nachfolger
    // Member functions
   public:
    // Constructor
    Auto(int az = 0, int nr = 0, float gew = 0.0) : Fahrzeug(az), AutoNr(nr), Gewicht(gew), Nachfolger(0) {}
    int getAutoNr () const { return AutoNr; }
    float getGewicht () const { return Gewicht; }
    void print () { cout << "Auto-Nr: " << AutoNr << ", Anzahl Passagiere: " << Anzahl << ", Gewicht: " << Gewicht << endl; }
	Auto *next () { return Nachfolger; }
};

class Autoliste  // Liste von Autos
{
   private:
    // Kopfzeiger
    Auto *Head;

   public:
	// Konstruktor für leere Liste
	Autoliste () : Head (0) { }
	// Einfügen eines Autos an den Anfang der Liste
	void insert (Auto * kp) {
		kp->Nachfolger = Head;
		Head = kp;
		cout << "Auto eingefügt." << endl;
    }

    // Entfernen eines Autos vom Ende der Liste
    Auto *removeLast() {
        Auto * kp = Head;
        if (Head != NULL)  // Falls Head nicht null ist (also Liste ist nicht leer)
        {
            // Falls es keinen Nachfolger gibt, dann Head auf NULL setzen
            if (Head->Nachfolger == NULL) {
                Head = NULL;
            } else {
                // Ansonsten durch die Liste gehen und den letzten Eintrag holen
                Auto *temp = Head;
                while (temp->Nachfolger->Nachfolger != NULL) temp = temp->Nachfolger;

                // Ändere den "Nachfolger" vom vorletzten Node, 
                // indem dieser auf null gesetzt wird.
	            // Mit free(lastNode); wird der Speicherplatz freigegeben
                Auto* lastNode = temp->Nachfolger;
                temp->Nachfolger = NULL;
                free(lastNode);
            }
        }
        return kp;
    }

    // Delete a Auto at the beginning of the list
    Auto *removeFirst() {
        Auto *kp = Head;
        if (kp != 0) {
            Head = kp->Nachfolger;
            kp->Nachfolger = 0;  // Ist das gleiche wie NULL bzw. null
            cout << "Auto gelöscht." << endl;
        }
        return kp;
    }

    Auto *find(int no) {
        Auto *ap;
        for (ap = begin(); ap != 0; ap = ap->next())
            if (ap->getAutoNr() == no) break;
        return ap;
    }

	// Anfang der Liste (Kopf)
	Auto *begin () const { return Head; }

	// Ist die Liste leer
	bool empty () const { return Head == 0; }
};

int main()
{
    int auswahl = 1;
    Autoliste list;
    int kNr, az;
    float gew;
    Auto *kp;

    do {
        system("cls");  //Löscht den Bildschirm für Windows-Systeme. Für Unix verwenden Sie system("clear"); - Sie können es auch weglassen
        cout << endl << "---- Auto-VERWALTUNG ----" << endl;
        cout << "1. Neues Auto anlegen" << endl;
        cout << "2. Auto löschen" << endl;
        cout << "3. Liste ausgeben" << endl;
        cout << "4. Datensatz suchen" << endl;
        cout << "0. Programm beenden" << endl;
        cout << "Auswahl: ";
        cin >> auswahl;
        cout << endl;

        switch (auswahl) {
            case 0:  // End
            	cout << "Bye Bye" << endl;
                cin.ignore();
                cin.get();
                break;
            case 1:  // CreAnlegenate
				cout << "AutoNr: ";
				cin >> kNr;
            	cout << "Anzahl Passagiere: ";
            	cin >> az;
				cout << "Gewicht: ";
				cin >> gew;
                list.insert(new Auto(az, kNr, gew));
                cin.ignore();
                cin.get();
                break;
            case 2:  // Löschen
                cout << "1. Am Anfang löschen" << endl;
                cout << "2. Am Ende löschen" << endl;
		        cout << "Auswahl: ";
                cin >> auswahl;
                if (auswahl == 1)
                    list.removeFirst();
                else
                    list.removeLast();
                cin.ignore();
                cin.get();
                break;
            case 3:  // Liste aller Autos
                for (kp = list.begin(); kp != 0; kp = kp->next()) kp->print();
                cin.ignore();
                cin.get();
                break;
            case 4:  // Auto anhand AutoNr suchen und falls gefunden, dann Anzahl Passagiere/Gewicht ausgeben
				Auto *objekt;
				cout << "Zu suchende AutoNr: ";
				cin >> kNr;
				objekt = list.find(kNr);
				if (objekt == 0)
					cout << "Auto nicht gefunden" << endl;
				else
					cout << "Anzahl Passagiere: " << objekt->getAnzahl() << endl << "Gewicht vom Auto: " << objekt->getGewicht() << endl;
                cin.ignore();
                cin.get();
                break;
            default:  // Falsche Auswahl
                cerr << "ERROR: incorrect input" << endl;
                cin.ignore();
                cin.get();
                break;
        }
    } while (auswahl != 0);

    // Alle Elemente in der Liste löschen
    while (!list.empty()) 
        list.removeFirst();

    return 0;
}
