#include <iostream>

using namespace std;

class Telefon {
   protected:  // Erlaubt Unterklassen den Zugriff auf die Attribute von der Oberklasse
    string farbe;
    int rufnummer;

   public:
    Telefon(string f, int nr): farbe(f), rufnummer(nr) { }
    // virtual void datenausgeben() {
    void datenausgeben() {
        cout << ">>Telefon<<" << endl;
        cout << "Farbe: " << farbe << " Rufnummer: " << rufnummer << endl;
    }
};

class KabelTelefon : public Telefon {
   private:
    int kabellaenge;

   public:
    KabelTelefon(string f, int nr, int kl) : Telefon(f, nr), kabellaenge(kl) {}
    void datenausgeben() {
        cout << ">>KabelTelefon<<" << endl;
        cout << "Farbe: " << farbe << " Rufnummer: " << rufnummer << endl;
        cout << "Kabellaenge: " << kabellaenge << " Meter" << endl;
    }
};

class MobilTelefon : public Telefon {
   private:
    string netz;

   public:
    MobilTelefon(string f, int nr, string n): Telefon(f, nr), netz(n) { }
    void datenausgeben() {
        cout << ">>MobilTelefon<<" << endl;
        cout << "Farbe: " << farbe << " Rufnummer: " << rufnummer << endl;
        cout << "Netz: " << netz << endl;
    }
};

int main() {
    Telefon *t = new Telefon("Schwarz", 49172123456);
    KabelTelefon *kt = new KabelTelefon("Blau", 4999123456, 2);
    MobilTelefon *mt = new MobilTelefon("Weiss", 491994433222211, "BestNetz");
    t->datenausgeben();
    t = kt;
    t->datenausgeben();
    t = mt;
    t->datenausgeben();

    // ohne virtual wird nur die Methode datenausgeben von Telefon aufgerufen
    // mit virtual wird die Methode datenausgeben von der dementsprechenden Klasse aufgerufen

    return 0;
}
