#include <iostream>

using namespace std;

class Fahrzeug {
   private:
    string marke;
    string kennzeichen;
    int ps;
    int baujahr;

   public:
    // Konstruktor mit Elementinitialisierungsliste
    Fahrzeug(string m, string k, int p, int bj): marke(m), kennzeichen(k), ps(p), baujahr(bj) {}

    // Methode um Daten auszugeben
    void datenausgeben() {
        cout << "Marke: " << marke << endl;
        cout << "Kennzeichen: " << kennzeichen << endl;
        cout << "Anzahl PS: " << ps << endl;
        cout << "Baujahr: " << baujahr << endl;
    }

    string getMarke() { return marke; }
    string getKennzeichen() { return kennzeichen; }
    int getPS() { return ps; }
    int getBaujahr() { return baujahr; }

    // Operator <= wird als Memberfunktion überladen
    void operator<=(Fahrzeug f1) {
        if (this->baujahr < f1.baujahr) {
            cout << "Fahrzug " << this->getMarke() << " ist älter als " << f1.getMarke() << endl;
        } else if (this->baujahr > f1.baujahr) {
            cout << "Fahrzug " << this->getMarke() << " ist jünger als " << f1.getMarke() << endl;
        } else {
            cout << "Beide Fahrzeuge sind gleich alt" << endl;
        }
    }
};

// Operatorüberladung - der Operator == wird überladen
// Die Funktioin wird als externe Funktion der Klasse deklariert
void operator==(Fahrzeug f1, Fahrzeug f2) {
    if (f1.getMarke() == f2.getMarke() && f1.getKennzeichen() == f2.getKennzeichen() && f1.getPS() == f2.getPS() && f1.getBaujahr() == f2.getBaujahr()) {
        cout << "Fahrzeuge sind gleich" << endl;
    } else {
        cout << "Fahrzeuge sind nicht gleich" << endl;
    }
}

int main() {
    // Instanz anlegen
    Fahrzeug fz1("Opel", "PA AA 333", 66, 1999);
    Fahrzeug fz2("BMW", "DEG DD 222", 103, 2005);

    // Vergleichsoperator wird aufgerufen
    fz1 == fz2;

    // Größer / kleiner Operator
    fz1 <= fz2;

    return 0;
};
