#include <stdlib.h> /* srand, rand */
#include <ctime>
#include <iostream>

using namespace std;

string form[3] = {"Schere", "Stein", "Papier"};

class Spieler {
   private:
    string name;
    int auswahl;
    int gewinn;
    int unentschieden;

   public:
    Spieler(string);
    void set_auswahl(int a) { auswahl = a; };
    int get_unentschieden() { return unentschieden; };
    friend bool operator==(const Spieler &p1, const Spieler &p2);
    friend bool operator>(const Spieler &p1, const Spieler &p2);
    friend bool operator>=(const Spieler &p1, const Spieler &p2);
    Spieler operator++();     // Prefix-Operator
    Spieler operator++(int);  // Postfix-Operator
    friend istream &operator>>(istream &input, Spieler &s);
    friend ostream &operator<<(ostream &output, Spieler &s);
};

Spieler::Spieler(string n) {
    gewinn = 0;
    unentschieden = 0;
    name = n;
}

bool operator==(const Spieler &p1, const Spieler &p2) {
    if (p1.auswahl == 0 && p2.auswahl == 0) {
        cout << form[0] << " gegen " << form[0];
        return true;
    } else if (p1.auswahl == 1 && p2.auswahl == 1) {
        cout << form[1] << " gegen " << form[1];
        return true;
    } else if (p1.auswahl == 2 && p2.auswahl == 2) {
        cout << form[2] << " gegen " << form[2];
        return true;
    }
    return false;
}

bool operator>(const Spieler &p1, const Spieler &p2) {
    if (p1.auswahl == 0 && p2.auswahl == 1) {
        return false;
    } else if (p1.auswahl == 1 && p2.auswahl == 0) {
        cout << form[1] << " schlaegt " << form[0];
        return true;
    } else if (p1.auswahl == 2 && p2.auswahl == 0) {
        return false;
    } else if (p1.auswahl == 0 && p2.auswahl == 2) {
        cout << form[0] << " schlaegt " << form[2];
        return true;
    } else if (p1.auswahl == 1 && p2.auswahl == 2) {
        return false;
    } else if (p1.auswahl == 2 && p2.auswahl == 1) {
        cout << form[2] << " schlaegt " << form[1];
        return true;
    }
    return false;
}

bool operator>=(const Spieler &p1, const Spieler &p2) {
    if (p1.gewinn > p2.gewinn) {
        cout << endl << endl << p1.name << " gewinnt!";
        return true;
    } else if (p2.gewinn > p1.gewinn) {
        cout << endl << endl << p2.name << " gewinnt!";
        return true;
    } else {
        cout << endl << endl << "Unentschieden! Es gibt keinen Gewinner.";
    }
    return false;
}

Spieler Spieler::operator++() {
    this->unentschieden++;
    return *this;
}

Spieler Spieler::operator++(int a) {
    this->gewinn++;
    return *this;
}

istream &operator>>(istream &input, Spieler &s) {
    cout << "Auswahl " << s.name << endl;
    cout << "[0] Schere" << endl;
    cout << "[1] Stein" << endl;
    cout << "[2] Papier" << endl;
    cout << "Auswahl: ";

    input >> s.auswahl;

    return input;
}

ostream &operator<<(ostream &output, Spieler &s) {
    output << endl << s.name << ":" << endl << "Gewinn: " << s.gewinn;

    return output;
}

int main() {
    Spieler sp("Spieler");
    Spieler pc("Computer");

    int anzahl = 0;

    do {
        system("cls");
        cout << "*****SPIEL*****" << endl << endl;
        cin >> sp;
        cout << endl;
        srand(time(NULL));              // Zufällige Zahlen anhand der Uhrzeit neu generieren
        pc.set_auswahl(rand() % 3);     // Zufällige Zahl zwischen 0 und 2

        if (sp == pc) {
            ++sp;
            ++pc;
        } else if (sp > pc) {
            sp++;
        } else if (pc > sp) {
            pc++;
        }

        anzahl++;

        cout << endl << endl;
        cin.ignore();
        cin.get();
    } while (anzahl < 5);

    cout << sp << endl << pc << endl << endl << "Unentschieden: " << sp.get_unentschieden();

    sp >= pc;

    return 0;
}
